<template>
  <q-page padding>
    <div v-if="pokemon">
      <q-toolbar style="height: 60px;">
        <q-btn
          to="/pokemons"
          icon="arrow_back"
          color="secondary"
          unelevated
          flat
          round
        />
        <q-separator vertical class="q-mx-sm" inset style="max-height: 44px;" />
        <q-img :src="image" style="width: 60px; max-height: 60px" />
        <q-toolbar-title class="text-secondary">
          <div>{{ pokemon.name | capitalize }}</div>
        </q-toolbar-title>
        <q-btn
          label="Edit"
          @click="editNotify"
          icon="edit"
          color="secondary"
          unelevated
        />
      </q-toolbar>
      <div class="q-py-md">
        <div>Types: {{ types }}</div>
        <div>Abilities: {{ abilities }}</div>
        <div class="q-mt-lg">
          <q-banner class="bg-secondary text-white" rounded>
            <div class="text-bold">Other detail params</div>
            <div class="q-pt-md">{{ pokemon }}</div>
          </q-banner>
        </div>
      </div>
    </div>
    <q-inner-loading :showing="loading">
      <q-spinner-puff size="50px" color="primary" />
    </q-inner-loading>
  </q-page>
</template>

<style></style>

<script>
import { mapState } from 'vuex'
import capitalize from 'lodash/capitalize'

export default {
  name: 'PokemonPage',
  computed: {
    ...mapState('pokemons', {
      // same as state >> state.pokemonDetail.data || null
      // optional chaining >> state?.pokemonDetail?.data ?? null
      pokemon: ({ pokemonDetail: { data } }) => data || null,
      loading: ({ pokemonDetail: { loading } }) => loading,
      error: ({ pokemonDetail: { error } }) => error,
    }),
    image() {
      return this.pokemon ? this.pokemon.sprites.front_default : ''
    },
    types() {
      return this.pokemon.types.map(t => capitalize(t.type.name)).join(', ')
    },
    abilities() {
      return this.pokemon.abilities
        .map(a => capitalize(a.ability.name))
        .join(', ')
    },
  },
  filters: {
    capitalize(value) {
      return capitalize(value)
    },
  },
  methods: {
    editNotify() {
      this.$q.notify({
        message: "Upssssi. You can't edit.",
        color: 'negative',
        position: 'top',
      })
    },
  },
  mounted() {
    this.$store.dispatch('pokemons/getPokemonDetail', {
      name: this.$route.params.name,
    })
  },
}
</script>
